/*
 *        HttxsfINT.c 1.2 92/02/08  
 */ 
/*
****************************************************************************

            Copyright 1991, by Sun Microsystems, Inc.
            Copyright 1991, by FUJITSU LIMITED.

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of Sun Microsystems, Inc. or
FUJITSU LIMITED not be used in advertising or publicity pertaining
to distribution of the software without specific, written prior
permission.  FUJITSU LIMITED and Sun Microsystems, Inc. make no
representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.

SUN MICROSYSTEMS, INC. AND FUJITSU LIMITED DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL FUJITSU LIMITED AND SUN
MICROSYSTEMS, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

  Author: Hideki Hiura (hhiura@Sun.COM) Sun Microsystems, Inc.
	  Riki Kawaguchi, FUJITSU LIMITED
          Tomoki Kuriki, FUJITSU LIMITED

****************************************************************************
*/
#ifndef lint
#ident  "@(#)HttxsfINT.c	1.22    93/02/12 SMI"
#endif

#ifdef X_LOCALE
#include <X11/Xlocale.h>
#else
#include <locale.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#if XlibSpecificationRelease != 5
#include <X11/XlibR5.h>
#endif /* XlibSpecificationRelease */
#include "XSunExt.h"
#include <X11/Xutil.h>
#include <X11/Xresource.h>

#ifdef SVR4
#include <libintl.h>
#endif

#include <X11/keysymdef.h>

#include "Htt.h"
extern	htt_t	*htt;
#include "HttXsfSun.h"

#define CMSG
#ifdef DEBUG

#define Private static
#define Public			/**/

#include <stdio.h>
Private int     byte_of_line = 16;
Private void    fmtprt();

Public void
_iml_xdmem(top, len)
    char           *top;
    int             len;
{
    register char  *i, *j;
    register        print_len;

    j = top + len;
    i = top;
    while ((print_len = j - i) > 0) {
	if (print_len > byte_of_line) {
	    fmtprt(i, i, byte_of_line);
	    i += byte_of_line;
	} else {
	    fmtprt(i, i, print_len);
	    break;
	}
    }
}

Private void
fmtprt(data, offset, lsize)
    char           *data;
    long            offset;
    short           lsize;
{
    short           n;
    char            linebuf[512];
    char           *line = linebuf, *p;

    sprintf(line, "  %08lx   ", offset);
    p = line + 13;
    for (n = 0; n < byte_of_line; n++) {
	*p++ = ' ';
	if (n >= lsize) {
	    sprintf(p, "    ");
	    p += 4;
	    ++n;
	} else {
	    sprintf(p, "%02x", *((unsigned char *) data + n));
	    p += 2;
	    if ((++n) == lsize)
		sprintf(p, "  ");
	    else
		sprintf(p, "%02x", *((unsigned char *) data + n));
	    p += 2;
	}
    }
    sprintf(p, "     ");
    p += 5;
    for (n = 0; n < byte_of_line; n++) {
	if (n >= lsize)
	    *p++ = ' ';
	else if (*(data + n) < 0x20)
	    /* else if (!isprint(*((unsigned char *)data + n))) */
	    *p++ = '.';
	else
	    *p++ = *(data + n);
    }
    *p = '\0';
    dbg_printf("%s\n", line);
}
Private long
htoi(p)
    register char  *p;		/* hex mojiretsu e no pointer */
{
    register long   n = 0;

    if (upper(p) == -1)
	return (-1);
    while (*p >= '0' && *p <= '9' || *p >= 'A' && *p <= 'F')
	n = n * 16 + (*p++ >= 'A' ? *(p - 1) - 7 : *(p - 1)) - '0';
    return (n);
}

Private
upper(p)
    register char  *p;		/* hex mojiretsu e no pointer */
{
    register char  *pp;

    for (pp = p; *pp; ++pp) {
	*pp = 'a' <= *pp && 'z' >= *pp ? *pp + 'A' - 'a' : *pp;
	if (!isxdigit(*pp))
	    return (-1);
    }
}

Private char   *
itoa(i, a)
    int             i;		/* mojiretsu ni henkan suru binary (8-32 bit)  */
    register char  *a;		/* decimal mojiretsu o kakunou area no
				 * address */
{
    register int    c = 0;
    register int    b = 0;
    int             s;
    register char   d;

    i = (s = i < 0) ? (-i) : i;
    do {
	*(a + c++) = i % 10 + '0';
    } while ((i /= 10) > 0);
    *(a + c++) = s ? '-' : '\0';
    *(a + c++) = '\0';
    for (c = strlen(a) - 1; b < c; d = *(a + b), *(a + b++) = *(a + c), *(a + c--) = d);
    return (a);
}
#endif

extern void	XimpPreEditStartSend();
extern void	XimpPreEditDrawSend();
extern void	XimpPreEditDoneSend();
extern void	XimpPreEditCaretSend();
extern void	XimpStatusStartSend();
extern void	XimpStatusDrawSend();
extern void	XimpStatusDoneSend();
extern void	XimpLookupStartSend();
extern void	XimpLookupDrawSend();
extern void	XimpLookupProcessSend();
extern void	XimpLookupDoneSend();
extern void	XsfPreeditDraw();
extern void	XsfStatusDraw();

static int	imli_getmtow() ;
static void	imli_rvdump();
static void	imli_XIMtextdump();
static void	imli_textdump2();

static int      (*opsw[MAX_IMM_OPCODE]) ();

/*
 * This function expects to be invoked from X*LookupString() basically. The
 * function value is meaningless if it's not invoked from X*LookupString()
 */
iml_inst *
iml_execute(s, rrv)
    iml_session_t  *s ;
    iml_inst       **rrv;
{
    iml_inst       *rv = *rrv;
    FXimp_Client   *ic = (FXimp_Client *)s->ic ;
    iml_inst       *i;
    iml_inst	   *result = NULL;
    XSFrrvCell     *cell;
    int             tr;
    int             r = XLookupNone;
    int             op;

    iml_post_proc(s, &rv) ; /* possible optimization and region management */
    /* New rrv Link cell Create */
    cell = (XSFrrvCell *) malloc(sizeof(XSFrrvCell));
    bzero(cell, sizeof(XSFrrvCell));

    /* rrv Link */
    cell->rv = rv;

    /* Cell Link to IC */
    cell->nlink = ic->cell_link;
    ic->cell_link = cell;

    for (; ic->cell_link ;) {
	cell = ic->cell_link;
	for (i = cell->rv; i != NULL; i = i->next) {
	    cell->rv = i->next;
	    cell->called_rv = i;
	    op = i->opcode & ~IMM_CB_RESULT_REQUIRED ;
	    if ((op < 0) || (op >= MAX_IMM_OPCODE)) {
		break;
	    }
	    ic->callback_flg = 0;
	    tr = (*opsw[op]) (ic, i, s->event);
	    if (i->opcode & IMM_CB_RESULT_REQUIRED) {
		if(result){
#ifdef SVR4
                    fprintf(stderr,dgettext("SUNW_XIM_HTT_MSG",
                            "htt: Warning - unexpected sequence(duplicated result request)\n"));
#else /* SVR4 */
                    fprintf(stderr,"htt: Warning - unexpected sequence(duplicated result request)\n");
#endif /* SVR4 */
		} else {
		    result = i ;
		}
	    }
#ifdef notdef
	    /*
	     * IMM_CB_RESULT_REQUIRED $@$O$b$O$dL58z$J12:08:48i%0$G$"$k!(J#
	     * result $@$,I,MW$J>l9g$O$=$3$GD>@\(J iml_execute $@$r8F$s$G!"(J
	     * $@$=$N(J returen value $@$r$&$1$H$k(J
	     */
	    if (i->opcode & IMM_CB_RESULT_REQUIRED) {
		if (ic->callback_flg == 0) {
		    if ((int)IMLogic(ic->id, &rrv,
				IML_SEND_RESULTS, i, NULL) >= 0) {
			tr = imliinterpret(ic, rrv, e);
			if (tr != XLookupNone)
			    r = tr;
			return (r);
		    }
		} else {
		    if (tr != XLookupNone)
			r = tr;
		    return (r);
		}
	    }
	    if (tr != XLookupNone)
		r = tr;
#endif	    
	}
	ic->cell_link = cell->nlink;
	free(cell);
    }
    return result ;
}

/*
 * Private int members
 */
Private int
imli_nop()
{
    return (XLookupNone);
}
Private int
imli_set_status(ic, rv)
    FXimp_Client   *ic;
    iml_inst       *rv;
{
    int             prev_status = ic->iml_status;

    ic->iml_status = *(iml_status_t *) & (rv->operand);
    ic->henkan_mode = ic->iml_status ;

    if (((ic->iml_status & IMLSTATUS_Henkan_Mode) != IMLSTATUS_Henkan_Mode) &&
	((prev_status & IMLSTATUS_Henkan_Mode) == IMLSTATUS_Henkan_Mode)) {
	XimpCnversionEnd(ic);
    } else if (((ic->iml_status & IMLSTATUS_Henkan_Mode) == IMLSTATUS_Henkan_Mode) &&
	((prev_status & IMLSTATUS_Henkan_Mode) != IMLSTATUS_Henkan_Mode)) {
	XimpProcessStart(ic);
    }
    return (XLookupNone);
}
Private int
imli_reset()
{
    /* NOT IMPLEMENTED */
    /* reset the ic */
    return (XLookupNone);
}
Private int
imli_keypress(ic, rv, e)  
    FXimp_Client   *ic;
    iml_inst       *rv;
    XKeyEvent      *e;
{
    imm_keypress_t *kp = (imm_keypress_t *)&rv->operand ;

    if ( ( ( ic->style2 & XIMP_FE_TYPE3 ) == XIMP_FE_TYPE3 )
	       && ( !ic->henkan_mode ) )
	return;

    e->keycode = kp->keycode ;
    e->state = kp->state ;
    XimpSendKeyEvent(e);
}
Private int
imli_commit(ic, rv, e)
    FXimp_Client   *ic;
    iml_inst       *rv;		/* return values from IMLogin() to be
				 * interpreted */
    XKeyEvent      *e;		/* If not invoked from X*LooupString, then
				 * NULL */
{
    /*
     * FIX ME! This routine can accept only multi byte.
     */
    committed_string_t *cs;
    int          ctlen;
    int		 mbslen;
    int		 wcslen;    
    wchar_t	*wbuf ;
    char        *ctbuf ;

    if ( ( ( ic->style2 & XIMP_FE_TYPE3 ) == XIMP_FE_TYPE3 )
       && ( !ic->henkan_mode ) )
	return;

    cs = (committed_string_t *) & rv->operand;
    mbslen = strlen(cs->string) ;
    wbuf = (wchar_t *)calloc(sizeof(wchar_t), mbslen + 1);
    /*
     * The following function is named as EUC_TO.. but according to the
     * source, this seems to mean EUC encoded wide char. UGAH!!
     * cs->string is mbs, so we must convert to wchar first!! UGAHHHHH!
     */
    wcslen = mbstowcs(wbuf, cs->string, mbslen);
    ctbuf = calloc(5, wcslen +1); /* 5 is maximam designation char length */
    ctlen = EUC_To_CompoundText(ctbuf, wbuf, wcslen);

#ifdef	DEBUG
    (void) dbg_printf("imli_commit : ic=%x\n", ic);
    (void) dbg_printf("imli_commit : mb cs->string\n");
    imli_textdump2(cs->string);
    (void) dbg_printf("imli_commit : wc converted string\n");
    imli_textdump2(wbuf);
    (void) dbg_printf("imli_commit : Convert string ( Compo )\n");
    imli_textdump2(ctbuf);
    (void) dbg_printf("imli_commit : ctlen=%d\n", ctlen);
#endif				/* DEBUG */

    /*
     * if this commited string is not composed but just returned,
     * KeySym must be returned.
     * Currently only controll char is needed.
     */
    if((wcslen == 1) && (wbuf[0] < 0x20)){
	int l ; /* length of Lookuped string */
	XComposeStatus NotSuppoted ;
	char XLookupBuf[sizeof(char)*2];
	KeySym keysym ;
	l = XLookupString(e,XLookupBuf,sizeof(char)*2,&keysym,&NotSuppoted);
	if((l == 1) && (cs->string[0] == XLookupBuf[0])){
	    XimpSendKeyEvent(e);
	    goto end_point;
	}
    } 
    if (  (  ( ic->ximp_version == XIMP_PROTO_35_GRP )
	  && ( ctlen > XSF_COMMIT_CMSG ) )
       || (  ( ic->ximp_version == XIMP_PROTO_40_GRP )
	  && ( ctlen > XSF_COMMIT_CMSG_MAX ) ) ) {
	XimpCommitSendProp(ic, ctbuf, ctlen);
	ic->callback_flg = 1;
	goto end_point;
    } else {
	XimpCommitSendCmsg(ic, ctbuf, ctlen);
	ic->callback_flg = 1;
	goto end_point;
    }

end_point:
    free(ctbuf);
    free(wbuf);
    return (cs->status);
}
Private int
imli_reset_return(ic, rv, e)
    FXimp_Client   *ic;
    iml_inst       *rv;		/* return values from IMLogin() to be
				 * interpreted */
    XKeyEvent      *e;		/* If not invoked from X*LooupString, then
				 * NULL */
{
    /*
     * FIX ME! This routine can accept only multi byte.
     */
    committed_string_t *cs;
    int          ctlen;
    int		 mbslen;
    int		 wcslen;    
    wchar_t	*wbuf ;
    char        *ctbuf ;

    cs = (committed_string_t *) & rv->operand;
    if(!(mbslen = strlen(cs->string))){
	XimpResetReturn(ic, NULL, 0);
	return XLookupNone ;
    }

    wbuf = (wchar_t *)calloc(sizeof(wchar_t), mbslen + 1);
    /*
     * The following function is named as EUC_TO.. but according to the
     * source, this seems to mean EUC encoded wide char. UGAH!!
     * cs->string is mbs, so we must convert to wchar first!! UGAHHHHH!
     */
    wcslen = mbstowcs(wbuf, cs->string, mbslen);
    ctbuf = calloc(5, wcslen +1); /* 5 is maximam designation char length */
    ctlen = EUC_To_CompoundText(ctbuf, wbuf, wcslen);

    XimpResetReturn(ic, ctbuf, ctlen);
    ic->callback_flg = 1;
    free(ctbuf);
    free(wbuf);
    return (cs->status);
}

Private int
imli_preedit_start(ic)
    FXimp_Client   *ic;
{
    int             (*p) () = ic->func.preedit_start;
    if (p) {
	(p) (ic);
    }
    return (XLookupNone);
}
Private int
imli_preedit_draw(ic, rv)
    FXimp_Client   *ic;
    iml_inst       *rv;
{
    int             (*p) () = ic->func.preedit_draw;
    if (p) {
	(p) (ic, rv);
    }
    return (XLookupNone);
}
Private int
imli_preedit_done(ic)
    FXimp_Client   *ic;
{
    int             (*p) () = ic->func.preedit_done;
    if (p) {
	(p) (ic);
    }
    return (XLookupNone);
}
Private int
imli_preedit_caret(ic, rv)
    FXimp_Client   *ic;
    iml_inst       *rv;
{
    int             (*p) () = ic->func.preedit_caret;
    if (p) {
	(p) (ic, rv);
    }
    return (XLookupNone);
}
Private int
imli_status_start(ic)
    FXimp_Client   *ic;
{
    int             (*p) () = ic->func.status_start;
    if (p) {
	(p) (ic);
    }
    return (XLookupNone);
}
Private int
imli_status_draw(ic, rv)
    FXimp_Client   *ic;
    iml_inst       *rv;
{
    int             (*p) () = ic->func.status_draw;
    if (p) {
	(p) (ic, rv);
    }
    return (XLookupNone);
}
Private int
imli_status_done(ic)
    FXimp_Client   *ic;
{
    int             (*p) () = ic->func.status_done;
    if (p) {
	(p) (ic);
    }
    return (XLookupNone);
}
Private int
imli_lookup_start(ic, rv, e)
    FXimp_Client   *ic;
    iml_inst       *rv;
    XKeyEvent      *e;
{
    int             (*p) () = ic->func.lookup_start;
    if (p) {
	(p) (ic, rv, e);
    }
    return (XLookupNone);
}
Private int
imli_lookup_draw(ic, rv)
    FXimp_Client   *ic;
    iml_inst       *rv;
{
    int             (*p) () = ic->func.lookup_draw;
    if (p) {
	(p) (ic, rv);
    }
    return (XLookupNone);
}
Private int
imli_lookup_process(ic, rv, e)
    FXimp_Client   *ic;
    iml_inst       *rv;
    XKeyEvent      *e;
{
    int             (*p) () = ic->func.lookup_process;
    if (p) {
	(p) (ic, rv, e);
    }
    return (XLookupNone);
}
Private int
imli_lookup_done(ic)
    FXimp_Client   *ic;
{
    int             (*p) () = ic->func.lookup_done;
    if (p) {
	(p) (ic);
    }
    return (XLookupNone);
}
Private int
imli_aux_start(ic)
    FXimp_Client   *ic;
{
    int             (*p) () = ic->func.aux_start;
    if (p) {
	(p) (ic);
    }
    return (XLookupNone);
}
Private int
imli_aux_draw(ic)
    FXimp_Client   *ic;
{
    int             (*p) () = ic->func.aux_draw;
    if (p) {
	(p) (ic);
    }
    return (XLookupNone);
}

Private int
imli_aux_done(ic)
    FXimp_Client   *ic;
{
    int             (*p) () = ic->func.aux_done;
    if (p) {
	(p) (ic);
    }
    return (XLookupNone);
}

/*
 * Call callback Functions...
 *	imli_preedit_start_callback,	imli_preedit_draw_callback,
 *	imli_preedit_done_callback,	imli_preedit_caret_callback,
 *	imli_status_start_callback,	imli_status_draw_callback,
 *	imli_status_done_callback,	imli_lookup_start_callback,
 *	imli_lookup_draw_callback,	imli_lookup_process_callback,
 *	imli_lookup_done_callback
 */
Private int
imli_preedit_start_callback(ic)
    FXimp_Client   *ic;
{
#ifdef	DEBUG
    dbg_printf("imli_preedit_start_callback : ic=%x\n", ic);
#endif
    XimpPreEditStartSend(ic);
    ic->callback_flg = 1;
    return (XLookupNone);
}

/* Pre-Edit Draw Callback Module */
Private int
imli_preedit_draw_callback(ic, rv)
    FXimp_Client   *ic;
    iml_inst       *rv;		/* return values from IMLogin() to be
				 * interpreted */
{
    XIMPreeditDrawCallbackStruct *pds =
			(XIMPreeditDrawCallbackStruct *) & rv->operand;

    XimpPreEditDrawSend( ic, pds ) ;

    ic->callback_flg = 1;
    return (XLookupNone);
}
Private int
imli_preedit_done_callback(ic)
    FXimp_Client   *ic;
{
#ifdef	DEBUG
    dbg_printf("imli_preedit_done_callback : ic=%x\n", ic);
#endif
    XimpPreEditDoneSend(ic);
    ic->callback_flg = 1;
    return (XLookupNone);
}
Private int
imli_preedit_caret_callback(ic, rv)
    FXimp_Client   *ic;
    iml_inst       *rv;
{
    XIMPreeditCaretCallbackStruct *pcs;

    pcs = (XIMPreeditCaretCallbackStruct *) & rv->operand;
#ifdef	DEBUG
    dbg_printf("imli_preedit_caret_callback : ic=%x\n", ic);
    dbg_printf("imli_preedit_caret_callback : pcs=%x\n", pcs);
#endif
    XimpPreEditCaretSend(ic, pcs);
    ic->callback_flg = 1;
    return (XLookupNone);
}
Private int
imli_status_start_callback(ic)
    FXimp_Client   *ic;
{
#ifdef	DEBUG
    dbg_printf("imli_status_start_callback : ic=%x\n", ic);
#endif
    XimpStatusStartSend(ic);
    ic->callback_flg = 1;
    return (XLookupNone);
}
Private int
imli_status_draw_callback(ic, rv)
    FXimp_Client   *ic;
    iml_inst       *rv;		/* return values from IMLogin() to be
				 * interpreted */
{
    XIMStatusDrawCallbackStruct *sds;
    int             sdslen;
    char            textarea[512];
    sds = (XIMStatusDrawCallbackStruct *) & rv->operand;

#ifdef	DEBUG
    dbg_printf("imli_status_draw_callback : ic=%x\n", ic);
    dbg_printf("imli_status_draw_callback : sds=%x\n", sds);
    imli_XIMtextdump(sds->data.text);
#endif				/* DEBUG */

    XimpStatusDrawSend( ic, sds );
    ic->callback_flg = 1;
    return (XLookupNone);
}
Private int
imli_status_done_callback(ic)
    FXimp_Client   *ic;
{
#ifdef	DEBUG
    dbg_printf("imli_status_done_callback : ic=%x\n", ic);
#endif
    XimpStatusDoneSend(ic);
    ic->callback_flg = 1;
    return (XLookupNone);
}

#ifdef LOOKUPCALLBACK
/*
 * NO LONGER LOOKUP CHOICE CALLBACK IS SUPPORTED
 * THERE ARE NO GUARANTEE ON THIS CHUNK OF CODE TO WORK
 */
Private int
imli_lookup_start_callback(ic, rv, e)
    FXimp_Client   *ic;
    iml_inst       *rv;		/* return values from IMLogin() to be
				 * interpreted */
    XKeyEvent      *e;
{
    XIMLookupStartCallbackStruct *lss;
    lss = (XIMLookupStartCallbackStruct *) & rv->operand;

#ifdef	DEBUG
    dbg_printf("imli_lookup_start_callback : ic=%x\n", ic);
    dbg_printf("imli_lookup_start_callback : lss=%x\n", lss);
    dbg_printf("imli_lookup_start_callback : e=%x\n", e);
#endif
    XimpLookupStartSend(ic, lss, e);
    ic->callback_flg = 1;
    return (XLookupNone);
}
Private int
imli_lookup_draw_callback(ic, rv)
    FXimp_Client   *ic;
    iml_inst       *rv;		/* return values from IMLogin() to be
				 * interpreted */
{
    XIMLookupDrawCallbackStruct *lds;
    lds = (XIMLookupDrawCallbackStruct *) & rv->operand;

#ifdef	DEBUG
    dbg_printf("imli_lookup_draw_callback : ic=%x\n", ic);
    dbg_printf("imli_lookup_draw_callback : lds=%x\n", lds);
#endif
    XimpLookupDrawSend(ic, lds, 1);
    ic->callback_flg = 1;
    return (XLookupNone);

}

Private int
imli_lookup_process_callback(ic, rv, e)
    FXimp_Client   *ic;
    iml_inst       *rv;		/* return values from IMLogin() to be
				 * interpreted */
    XKeyEvent      *e;
{
#ifdef	DEBUG
    dbg_printf("imli_lookup_process_callback : ic=%x\n", ic);
    dbg_printf("imli_lookup_process_callback : e=%x\n", e);
#endif
    XimpLookupProcessSend(ic, e);
    ic->callback_flg = 1;
    return (XLookupNone);
}
Private int
imli_lookup_done_callback(ic)
    FXimp_Client   *ic;
{
#ifdef	DEBUG
    dbg_printf("imli_lookup_done_callback : ic=%x\n", ic);
#endif
    XimpLookupDoneSend(ic);
    ic->callback_flg = 1;
    return (XLookupNone);
}
#endif /* LOOKUPCALLBACK */

Private int
imli_key_info(ic, rv)
    FXimp_Client   *ic;
    iml_inst       *rv;		/* return values from IMLogin() to be
				 * interpreted */
{
#ifdef	DEBUG
    dbg_printf("imli_key_info CALL\n");
#endif
    return (XLookupNone);
}
Private int
imli_put_queue(ic, rv, event)
    FXimp_Client   *ic;
    iml_inst       *rv;		/* return values from IMLogin() to be
				 * interpreted */
    XKeyEvent      *event;	/* If not invoked from X*LooupString, then
				 * NULL */
{
    Display     *display = GET_HTT_VALUE(htt, display);
    extern int		putback_flag;
    /* only set ic->conv_on to ON in XmbLookupString */
    /*
     * PARANOIA: check event.
     */
#ifdef	DEBUG
    dbg_printf("imli_put_queue CALL\n");
#endif
    if (event) {
	XPutBackEvent(display, event);
    }
    putback_flag = 1;
    return (XLookupNone);
}

/*
 * Drawing Functions...
 *      imli_preedit_draw_server,       imli_preedit_caret_server,
 *      imli_lookup_draw_server,       	imli_lookup_process_server,
 *      imli_status_draw_server
 */
Private int
imli_preedit_draw_server( ic, rv )
    FXimp_Client    *ic ;
    iml_inst        *rv ;    /* Return values from IMLogic()
						to be interpreted */
{
    XIMPreeditDrawCallbackStruct	*pds ;
    wchar_t				*preedit_string ;
    int					 preedit_length ;
    pds = (XIMPreeditDrawCallbackStruct *)&rv->operand ;

#ifdef	DEBUG
    dbg_printf("** PreEditDraw-Server **\n");
    dbg_printf("    ic = %x\n", ic);
    dbg_printf("    pds = %x\n", pds);
#endif
    XsfPreeditDraw( ic, pds ) ;

    return ( XLookupNone ) ;
}

Private int
imli_preedit_caret_server( ic, rv )
    FXimp_Client	*ic ;
    iml_inst		*rv ;	/* Return values from IMLogic()
					     to be interpreted */
{
    /*
     * Not Yet Fixed
     */
    return ( XLookupNone ) ;
}

Private int
imli_lookup_start_server( ic, rv )
    FXimp_Client    *ic ;
    iml_inst        *rv ;	/* Return values from IMLogic()
				 *   to be interpreted */
{
    /*
     * Not Yet Fixed
     */
    lookup_start_server( ic, rv ) ;

    return ( XLookupNone ) ;
}

Private int
imli_lookup_draw_server( ic, rv )
    FXimp_Client	*ic ;
    iml_inst		*rv ;	/* Return values from IMLogic() to be
				 *  interpreted */
{
    /*
     * Not Yet Fixed
     */
    lookup_draw_server( ic, rv ) ;

    return ( XLookupNone ) ;
}

Private int
imli_lookup_process_server( ic, rv )
    FXimp_Client	*ic ;
    iml_inst		*rv ;	/* Return values from IMLogic() to be
    				 *  interpreted */
{
    /*
     * Not Yet Fixed
     */
    lookup_process_server( ic, rv ) ;

    return ( XLookupNone ) ;
}

Private int
imli_lookup_done_server( ic, rv )
    FXimp_Client	*ic ;
    iml_inst		*rv ;	/* Return values from IMLogic() to be
				 *  interpreted */
{
    /*
     * Not Yet Fixed
     */
    lookup_done_server( ic ) ;

    return ( XLookupNone ) ;

}

Private int
imli_status_draw_server( ic, rv )
    FXimp_Client	*ic ;
    iml_inst		*rv ;	/* Return values from IMLogic() to be
				 *  interpreted */
{
    XIMStatusDrawCallbackStruct		*sds ;
    sds = (XIMStatusDrawCallbackStruct *)&rv->operand ;

#ifdef	DEBUG
    dbg_printf( "** Status-Draw-Server **\n" ) ;
#endif
    XsfStatusDraw( ic, sds );
    return ( XLookupNone ) ;
}

void
imlimgr_init()
{
    if (opsw[IMM_NOP])
	return;

    opsw[IMM_NOP] = imli_nop;
    opsw[IMM_SET_STATUS] = imli_set_status;
    opsw[IMM_RESET] = imli_reset;
    opsw[IMM_COMMIT] = imli_commit;
    opsw[IMM_KEY_INFO] = imli_key_info;
    opsw[IMM_PUT_QUEUE] = imli_put_queue;

    opsw[IMM_PREEDIT_START] = imli_preedit_start;
    opsw[IMM_PREEDIT_DRAW] = imli_preedit_draw;
    opsw[IMM_PREEDIT_DONE] = imli_preedit_done;
    opsw[IMM_PREEDIT_CARET] = imli_preedit_caret;

    opsw[IMM_STATUS_START] = imli_status_start;
    opsw[IMM_STATUS_DRAW] = imli_status_draw;
    opsw[IMM_STATUS_DONE] = imli_status_done;

    opsw[IMM_LOOKUP_START] = imli_lookup_start;
    opsw[IMM_LOOKUP_DRAW] = imli_lookup_draw;
    opsw[IMM_LOOKUP_PROCESS] = imli_lookup_process;
    opsw[IMM_LOOKUP_DONE] = imli_lookup_done;

    opsw[IMM_KEYPRESS] = imli_keypress;
    opsw[IMM_RESET_RETURN] = imli_reset_return;
    return;

}

/* Client Function Pointer Records Initialize */
void
imlimgr_client_init(ic)
    FXimp_Client   *ic;
{

    if ( ic->style & XIMPreeditArea ) {
        ic->func.preedit_draw = imli_preedit_draw_server ;
        ic->func.preedit_caret = imli_preedit_caret_server ;
    }
    if ( ic->style & XIMPreeditNothing ) {
	ic->func.preedit_draw = imli_preedit_draw_server ;
	ic->func.preedit_caret = imli_preedit_caret_server ;
    }
    if ( ic->style & XIMPreeditPosition ) {
	ic->func.preedit_draw = imli_preedit_draw_server ;
	ic->func.preedit_caret = imli_preedit_caret_server ;
    }
    if ( ic->style & XIMPreeditCallbacks ) {
	ic->func.preedit_start = imli_preedit_start_callback ;
	ic->func.preedit_draw = imli_preedit_draw_callback ;
	ic->func.preedit_caret = imli_preedit_caret_callback ;
	ic->func.preedit_done = imli_preedit_done_callback ;
    }
    if ( ic->style & XIMStatusNothing ) {
	ic->func.status_draw = imli_status_draw_server ;
    }
    if ( ic->style & XIMStatusArea ) {
	ic->func.status_draw = imli_status_draw_server ;
    }
    if ( ic->style & XIMStatusCallbacks ) {
	ic->func.status_start = imli_status_start_callback ;
	ic->func.status_draw = imli_status_draw_callback ;
	ic->func.status_done = imli_status_done_callback ;
    }

    /* Defaults Function Pointer ( Extent Records ) Setting */
    ic->func.lookup_start = imli_lookup_start_server ;
    ic->func.lookup_draw = imli_lookup_draw_server ;
    ic->func.lookup_process = imli_lookup_process_server ;
    ic->func.lookup_done = imli_lookup_done_server ;

#ifdef LOOKUPCALLBACK
/*
 * NO LONGER LOOKUP CHOICE CALLBACK IS SUPPORTED
 * THERE ARE NO GUARANTEE ON THIS CHUNK OF CODE TO WORK
 */
    if ( ic->style & XIMLookupCallbacks ) {
	ic->func.lookup_start = imli_lookup_start_callback ;
	ic->func.lookup_draw = imli_lookup_draw_callback ;
	ic->func.lookup_process = imli_lookup_process_callback ;
	ic->func.lookup_done = imli_lookup_done_callback ;
    }
#endif /* LOOKUPCALLBACK */
    return ;

}

/* Client Function Pointer ( Extent ) Records Initialize */
void
imlimgr_client_ext_init(ic)
    FXimp_Client   *ic;
{
#ifdef LOOKUPCALLBACK
/*
 * NO LONGER LOOKUP CHOICE CALLBACK IS SUPPORTED
 * THERE ARE NO GUARANTEE ON THIS CHUNK OF CODE TO WORK
 */
    ic->func.lookup_start = imli_lookup_start_callback;
    ic->func.lookup_draw = imli_lookup_draw_callback;
    ic->func.lookup_process = imli_lookup_process_callback;
    ic->func.lookup_done = imli_lookup_done_callback;
#endif /* LOOKUPCALLBACK */
    return;

}

#ifdef	DEBUG
Private int      rvtbl[] = {
     /* IMM_NOP */ 0,
     /* IMM_RESET */ 0,
     /* IMM_COMMIT */ 14,
     /* IMM_SET_STATUS */ sizeof(iml_status_t),
     /* IMM_PREEDIT_START */ 0,
     /* IMM_PREEDIT_DRAW */ 36,
     /* IMM_PREEDIT_CARET */ 0,
     /* IMM_PREEDIT_DONE */ 0,
     /* IMM_LOOKUP_START */ 0,
     /* IMM_LOOKUP_DRAW */ sizeof(XIMLookupDrawCallbackStruct),
     /* IMM_LOOKUP_PROCES */ sizeof(XIMLookupProcessCallbackStruct),
     /* IMM_LOOKUP_DONE */ 0,
     /* IMM_KEY_INFO */ 0,
     /* IMM_PUT_QUEUE */ 0,
     /* IMM_STATUS_START */ 0,
     /* IMM_STATUS_DRAW */ sizeof(XIMStatusDrawCallbackStruct),
     /* IMM_STATUS_DONE */ 0,
     /* IMM_AUX_START */ 0,
     /* IMM_AUX_DRAW */ 0,
     /* IMM_AUX_PROCESS */ 0,
     /* IMM_AUX_DONE */ 0
};

Private void
imli_rvdump(rv)
    iml_inst       *rv;
{

    int             i, op;
    unsigned char  *ptr;

    dbg_printf("===iml_inst Dump===\n");
    dbg_printf("  rv-addr   : %8.8x\n", rv);
    dbg_printf("  next-link : %8.8x\n", rv->next);
    dbg_printf("  op-size   : %d\n", rv->size_of_operand);
    op = rv->opcode & ~IMM_CB_RESULT_REQUIRED;
    dbg_printf("  opcode    : %d\n", op);
    dbg_printf("  oprand    : %8.8x\n", rv->operand);

    for (i = rvtbl[op], ptr = (unsigned char *)&rv->operand;
			i > 0; i--, ptr++) {
	dbg_printf("%2.2x ", *ptr);
    }
    dbg_printf("\n", *ptr);
}

Private void
imli_XIMtextdump(text)
    XIMText        *text;
{

    int             i;
    unsigned char  *ptr;

    dbg_printf("===XIMtext Dump===\n");
    dbg_printf("  XIMtext Addr: %8.8x\n", text);
    if (!text)
	return;
    dbg_printf("  Length of Str.: %d\n", text->length);
    dbg_printf("  Encoding: %d\n", text->encoding_is_wchar);
    if (text->feedback) {
	dbg_printf("  FeedBacks Addr: %8.8x\n", text->feedback);
	for (i = text->length * 4, ptr = (unsigned char *)text->feedback;
	     i > 0; i--, ptr++) {
	    dbg_printf(" %2.2x", *ptr);
	}
    }
    if (text->string.multi_byte) {
	dbg_printf("\n	multi_byte Addr: %8.8x\n", text->string.multi_byte);
	for (i = text->length * 2,
			ptr = (unsigned char *)text->string.multi_byte;
			i > 0; i--, ptr++) {
	    dbg_printf(" %2.2x", *ptr);
	}
    }
    dbg_printf("\n");
}

Private void
imli_textdump2(text)
    char           *text;
{

    int             i;
    unsigned char  *ptr;

    dbg_printf("=== Convert Text ===\n");
    for (i = strlen(text), ptr = (unsigned char *)text; i > 0; i--, ptr++) {
	dbg_printf(" %2.2x", *ptr);
    }
    dbg_printf("\n");
}

#endif	/* DEBUG */
